org.apache.xalan.transformer

## Class TransformerHandlerImpl

- java.lang.Object
- - org.apache.xalan.transformer.TransformerHandlerImpl

All Implemented Interfaces:
  TransformerHandler, ContentHandler, DTDHandler, EntityResolver, ErrorHandler, DeclHandler, LexicalHandler

    public class TransformerHandlerImpl
    extends java.lang.Object
    implements EntityResolver, DTDHandler, ContentHandler, ErrorHandler, LexicalHandler, TransformerHandler, DeclHandler

A TransformerHandler listens for SAX ContentHandler parse events and transforms them to a Result.

### Constructor Summary

Constructors
Constructor and Description
`TransformerHandlerImpl(TransformerImpl transformer, boolean doFragment, java.lang.String baseSystemID)` Construct a TransformerHandlerImpl.

### Method Summary

Methods
`void` `attributeDecl(java.lang.String eName, java.lang.String aName, java.lang.String type, java.lang.String valueDefault, java.lang.String value)` Report an attribute type declaration.
`void` `characters(char[] ch, int start, int length)` Filter a character data event.
`void` `comment(char[] ch, int start, int length)` Report an XML comment anywhere in the document.
`void` `elementDecl(java.lang.String name, java.lang.String model)` Report an element type declaration.
`void` `endCDATA()` Report the end of a CDATA section.
`void` `endDocument()` Filter an end document event.
`void` `endDTD()` Report the end of DTD declarations.
`void` `endElement(java.lang.String uri, java.lang.String localName, java.lang.String qName)` Filter an end element event.
`void` `endEntity(java.lang.String name)` Report the end of an entity.
`void` `endPrefixMapping(java.lang.String prefix)` Filter an end Namespace prefix mapping event.
`void` `error(SAXParseException e)` Filter an error event.
`void` `externalEntityDecl(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` Report a parsed external entity declaration.
`void` `fatalError(SAXParseException e)` Filter a fatal error event.
`java.lang.String` `getSystemId()` Get the base ID (URI or system ID) from where relative URLs will be resolved.
`Transformer` `getTransformer()` Get the Transformer associated with this handler, which is needed in order to set parameters and output properties.
`void` `ignorableWhitespace(char[] ch, int start, int length)` Filter an ignorable whitespace event.
`void` `internalEntityDecl(java.lang.String name, java.lang.String value)` Report an internal entity declaration.
`void` `notationDecl(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` Filter a notation declaration event.
`void` `processingInstruction(java.lang.String target, java.lang.String data)` Filter a processing instruction event.
`InputSource` `resolveEntity(java.lang.String publicId, java.lang.String systemId)` Filter an external entity resolution.
`void` `setDocumentLocator(Locator locator)` Filter a new document locator event.
`void` `setResult(Result result)` Enables the user of the TransformerHandler to set the to set the Result for the transformation.
`void` `setSystemId(java.lang.String systemID)` Set the base ID (URI or system ID) from where relative URLs will be resolved.
`void` `skippedEntity(java.lang.String name)` Filter a skipped entity event.
`void` `startCDATA()` Report the start of a CDATA section.
`void` `startDocument()` Filter a start document event.
`void` `startDTD(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` Report the start of DTD declarations, if any.
`void` `startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName, Attributes atts)` Filter a start element event.
`void` `startEntity(java.lang.String name)` Report the beginning of an entity in content.
`void` `startPrefixMapping(java.lang.String prefix, java.lang.String uri)` Filter a start Namespace prefix mapping event.
`void` `unparsedEntityDecl(java.lang.String name, java.lang.String publicId, java.lang.String systemId, java.lang.String notationName)` Filter an unparsed entity declaration event.
`void` `warning(SAXParseException e)` Filter a warning event.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### TransformerHandlerImpl

    public TransformerHandlerImpl(TransformerImpl transformer,
                          boolean doFragment,
                          java.lang.String baseSystemID)

Construct a TransformerHandlerImpl.

Parameters:
  `transformer` - Non-null reference to the Xalan transformer impl.
  `doFragment` - True if the result should be a document fragement.
  `baseSystemID` - The system ID to use as the base for relative URLs.

### Method Detail

#### setResult

    public void setResult(Result result)
                   throws java.lang.IllegalArgumentException

Enables the user of the TransformerHandler to set the to set the Result for the transformation.

Specified by:
  `setResult` in interface `TransformerHandler`
Parameters:
  `result` - A Result instance, should not be null.
Throws:
  `java.lang.IllegalArgumentException` - if result is invalid for some reason.

#### setSystemId

    public void setSystemId(java.lang.String systemID)

Set the base ID (URI or system ID) from where relative URLs will be resolved.

Specified by:
  `setSystemId` in interface `TransformerHandler`
Parameters:
  `systemID` - Base URI for the source tree.

#### getSystemId

    public java.lang.String getSystemId()

Get the base ID (URI or system ID) from where relative URLs will be resolved.

Specified by:
  `getSystemId` in interface `TransformerHandler`
Returns:
  The systemID that was set with `setSystemId(java.lang.String)`.

#### getTransformer

    public Transformer getTransformer()

Get the Transformer associated with this handler, which is needed in order to set parameters and output properties.

Specified by:
  `getTransformer` in interface `TransformerHandler`
Returns:
  The Transformer associated with this handler

#### resolveEntity

    public InputSource resolveEntity(java.lang.String publicId,
                            java.lang.String systemId)
                              throws SAXException,
                                     java.io.IOException

Filter an external entity resolution.

Specified by:
  `resolveEntity` in interface `EntityResolver`
Parameters:
  `publicId` - The entity's public identifier, or null.
  `systemId` - The entity's system identifier.
Returns:
  A new InputSource or null for the default.
Throws:
  `java.io.IOException`
  `SAXException` - The client may throw an exception during processing.
  `java.io.IOException` - The client may throw an I/O-related exception while obtaining the new InputSource.
See Also:
  `EntityResolver.resolveEntity(java.lang.String, java.lang.String)`

#### notationDecl

    public void notationDecl(java.lang.String name,
                    java.lang.String publicId,
                    java.lang.String systemId)
                      throws SAXException

Filter a notation declaration event.

Specified by:
  `notationDecl` in interface `DTDHandler`
Parameters:
  `name` - The notation name.
  `publicId` - The notation's public identifier, or null.
  `systemId` - The notation's system identifier, or null.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `DTDHandler.notationDecl(java.lang.String, java.lang.String, java.lang.String)`

#### unparsedEntityDecl

    public void unparsedEntityDecl(java.lang.String name,
                          java.lang.String publicId,
                          java.lang.String systemId,
                          java.lang.String notationName)
                            throws SAXException

Filter an unparsed entity declaration event.

Specified by:
  `unparsedEntityDecl` in interface `DTDHandler`
Parameters:
  `name` - The entity name.
  `publicId` - The entity's public identifier, or null.
  `systemId` - The entity's system identifier, or null.
  `notationName` - The name of the associated notation.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `DTDHandler.unparsedEntityDecl(java.lang.String, java.lang.String, java.lang.String, java.lang.String)`

#### setDocumentLocator

    public void setDocumentLocator(Locator locator)

Filter a new document locator event.

Specified by:
  `setDocumentLocator` in interface `ContentHandler`
Parameters:
  `locator` - The document locator.
See Also:
  `ContentHandler.setDocumentLocator(org.xml.sax.Locator)`

#### startDocument

    public void startDocument()
                       throws SAXException

Filter a start document event.

Specified by:
  `startDocument` in interface `ContentHandler`
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ContentHandler.startDocument()`

#### endDocument

    public void endDocument()
                     throws SAXException

Filter an end document event.

Specified by:
  `endDocument` in interface `ContentHandler`
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ContentHandler.endDocument()`

#### startPrefixMapping

    public void startPrefixMapping(java.lang.String prefix,
                          java.lang.String uri)
                            throws SAXException

Filter a start Namespace prefix mapping event.

Specified by:
  `startPrefixMapping` in interface `ContentHandler`
Parameters:
  `prefix` - The Namespace prefix.
  `uri` - The Namespace URI.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ContentHandler.startPrefixMapping(java.lang.String, java.lang.String)`

#### endPrefixMapping

    public void endPrefixMapping(java.lang.String prefix)
                          throws SAXException

Filter an end Namespace prefix mapping event.

Specified by:
  `endPrefixMapping` in interface `ContentHandler`
Parameters:
  `prefix` - The Namespace prefix.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ContentHandler.endPrefixMapping(java.lang.String)`

#### startElement

    public void startElement(java.lang.String uri,
                    java.lang.String localName,
                    java.lang.String qName,
                    Attributes atts)
                      throws SAXException

Filter a start element event.

Specified by:
  `startElement` in interface `ContentHandler`
Parameters:
  `uri` - The element's Namespace URI, or the empty string.
  `localName` - The element's local name, or the empty string.
  `qName` - The element's qualified (prefixed) name, or the empty string.
  `atts` - The element's attributes.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ContentHandler.startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`

#### endElement

    public void endElement(java.lang.String uri,
                  java.lang.String localName,
                  java.lang.String qName)
                    throws SAXException

Filter an end element event.

Specified by:
  `endElement` in interface `ContentHandler`
Parameters:
  `uri` - The element's Namespace URI, or the empty string.
  `localName` - The element's local name, or the empty string.
  `qName` - The element's qualified (prefixed) name, or the empty string.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ContentHandler.endElement(java.lang.String, java.lang.String, java.lang.String)`

#### characters

    public void characters(char[] ch,
                  int start,
                  int length)
                    throws SAXException

Filter a character data event.

Specified by:
  `characters` in interface `ContentHandler`
Parameters:
  `ch` - An array of characters.
  `start` - The starting position in the array.
  `length` - The number of characters to use from the array.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ContentHandler.characters(char[], int, int)`

#### ignorableWhitespace

    public void ignorableWhitespace(char[] ch,
                           int start,
                           int length)
                             throws SAXException

Filter an ignorable whitespace event.

Specified by:
  `ignorableWhitespace` in interface `ContentHandler`
Parameters:
  `ch` - An array of characters.
  `start` - The starting position in the array.
  `length` - The number of characters to use from the array.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ContentHandler.ignorableWhitespace(char[], int, int)`

#### processingInstruction

    public void processingInstruction(java.lang.String target,
                             java.lang.String data)
                               throws SAXException

Filter a processing instruction event.

Specified by:
  `processingInstruction` in interface `ContentHandler`
Parameters:
  `target` - The processing instruction target.
  `data` - The text following the target.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ContentHandler.processingInstruction(java.lang.String, java.lang.String)`

#### skippedEntity

    public void skippedEntity(java.lang.String name)
                       throws SAXException

Filter a skipped entity event.

Specified by:
  `skippedEntity` in interface `ContentHandler`
Parameters:
  `name` - The name of the skipped entity.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ContentHandler.skippedEntity(java.lang.String)`

#### warning

    public void warning(SAXParseException e)
                 throws SAXException

Filter a warning event.

Specified by:
  `warning` in interface `ErrorHandler`
Parameters:
  `e` - The nwarning as an exception.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ErrorHandler.warning(org.xml.sax.SAXParseException)`

#### error

    public void error(SAXParseException e)
               throws SAXException

Filter an error event.

Specified by:
  `error` in interface `ErrorHandler`
Parameters:
  `e` - The error as an exception.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ErrorHandler.error(org.xml.sax.SAXParseException)`

#### fatalError

    public void fatalError(SAXParseException e)
                    throws SAXException

Filter a fatal error event.

Specified by:
  `fatalError` in interface `ErrorHandler`
Parameters:
  `e` - The error as an exception.
Throws:
  `SAXException` - The client may throw an exception during processing.
See Also:
  `ErrorHandler.fatalError(org.xml.sax.SAXParseException)`

#### startDTD

    public void startDTD(java.lang.String name,
                java.lang.String publicId,
                java.lang.String systemId)
                  throws SAXException

Report the start of DTD declarations, if any.

Any declarations are assumed to be in the internal subset unless otherwise indicated by a `startEntity` event.

Note that the start/endDTD events will appear within the start/endDocument events from ContentHandler and before the first startElement event.

Specified by:
  `startDTD` in interface `LexicalHandler`
Parameters:
  `name` - The document type name.
  `publicId` - The declared public identifier for the external DTD subset, or null if none was declared.
  `systemId` - The declared system identifier for the external DTD subset, or null if none was declared.
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `endDTD()`, `startEntity(java.lang.String)`

#### endDTD

    public void endDTD()
                throws SAXException

Report the end of DTD declarations.

Specified by:
  `endDTD` in interface `LexicalHandler`
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `startDTD(java.lang.String, java.lang.String, java.lang.String)`

#### startEntity

    public void startEntity(java.lang.String name)
                     throws SAXException

Report the beginning of an entity in content.

NOTE:</entity> entity references in attribute values -- and the start and end of the document entity -- are never reported.

The start and end of the external DTD subset are reported using the pseudo-name "[dtd]". All other events must be properly nested within start/end entity events.

Note that skipped entities will be reported through the `skippedEntity` event, which is part of the ContentHandler interface.

Specified by:
  `startEntity` in interface `LexicalHandler`
Parameters:
  `name` - The name of the entity. If it is a parameter entity, the name will begin with '%'.
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `endEntity(java.lang.String)`, `DeclHandler.internalEntityDecl(java.lang.String, java.lang.String)`, `DeclHandler.externalEntityDecl(java.lang.String, java.lang.String, java.lang.String)`

#### endEntity

    public void endEntity(java.lang.String name)
                   throws SAXException

Report the end of an entity.

Specified by:
  `endEntity` in interface `LexicalHandler`
Parameters:
  `name` - The name of the entity that is ending.
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `startEntity(java.lang.String)`

#### startCDATA

    public void startCDATA()
                    throws SAXException

Report the start of a CDATA section.

The contents of the CDATA section will be reported through the regular `characters` event.

Specified by:
  `startCDATA` in interface `LexicalHandler`
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `endCDATA()`

#### endCDATA

    public void endCDATA()
                  throws SAXException

Report the end of a CDATA section.

Specified by:
  `endCDATA` in interface `LexicalHandler`
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `startCDATA()`

#### comment

    public void comment(char[] ch,
               int start,
               int length)
                 throws SAXException

Report an XML comment anywhere in the document.

This callback will be used for comments inside or outside the document element, including comments in the external DTD subset (if read).

Specified by:
  `comment` in interface `LexicalHandler`
Parameters:
  `ch` - An array holding the characters in the comment.
  `start` - The starting position in the array.
  `length` - The number of characters to use from the array.
Throws:
  `SAXException` - The application may raise an exception.

#### elementDecl

    public void elementDecl(java.lang.String name,
                   java.lang.String model)
                     throws SAXException

Report an element type declaration.

The content model will consist of the string "EMPTY", the string "ANY", or a parenthesised group, optionally followed by an occurrence indicator. The model will be normalized so that all whitespace is removed,and will include the enclosing parentheses.

Specified by:
  `elementDecl` in interface `DeclHandler`
Parameters:
  `name` - The element type name.
  `model` - The content model as a normalized string.
Throws:
  `SAXException` - The application may raise an exception.

#### attributeDecl

    public void attributeDecl(java.lang.String eName,
                     java.lang.String aName,
                     java.lang.String type,
                     java.lang.String valueDefault,
                     java.lang.String value)
                       throws SAXException

Report an attribute type declaration.

Only the effective (first) declaration for an attribute will be reported. The type will be one of the strings "CDATA", "ID", "IDREF", "IDREFS", "NMTOKEN", "NMTOKENS", "ENTITY", "ENTITIES", or "NOTATION", or a parenthesized token group with the separator "|" and all whitespace removed.

Specified by:
  `attributeDecl` in interface `DeclHandler`
Parameters:
  `eName` - The name of the associated element.
  `aName` - The name of the attribute.
  `type` - A string representing the attribute type.
  `valueDefault` - A string representing the attribute default ("#IMPLIED", "#REQUIRED", or "#FIXED") or null if none of these applies.
  `value` - A string representing the attribute's default value, or null if there is none.
Throws:
  `SAXException` - The application may raise an exception.

#### internalEntityDecl

    public void internalEntityDecl(java.lang.String name,
                          java.lang.String value)
                            throws SAXException

Report an internal entity declaration.

Only the effective (first) declaration for each entity will be reported.

Specified by:
  `internalEntityDecl` in interface `DeclHandler`
Parameters:
  `name` - The name of the entity. If it is a parameter entity, the name will begin with '%'.
  `value` - The replacement text of the entity.
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `externalEntityDecl(java.lang.String, java.lang.String, java.lang.String)`, `DTDHandler.unparsedEntityDecl(java.lang.String, java.lang.String, java.lang.String, java.lang.String)`

#### externalEntityDecl

    public void externalEntityDecl(java.lang.String name,
                          java.lang.String publicId,
                          java.lang.String systemId)
                            throws SAXException

Report a parsed external entity declaration.

Only the effective (first) declaration for each entity will be reported.

Specified by:
  `externalEntityDecl` in interface `DeclHandler`
Parameters:
  `name` - The name of the entity. If it is a parameter entity, the name will begin with '%'.
  `publicId` - The declared public identifier of the entity, or null if none was declared.
  `systemId` - The declared system identifier of the entity.
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `internalEntityDecl(java.lang.String, java.lang.String)`, `DTDHandler.unparsedEntityDecl(java.lang.String, java.lang.String, java.lang.String, java.lang.String)`